/* macro.c generated by valac 0.56.17, the Vala compiler
 * generated from macro.vala, do not modify */

/* Macro facility functions

   Copyright (c) 1997-2021 Free Software Foundation, Inc.

   This file is part of GNU Zile.

   GNU Zile is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   GNU Zile is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, see <https://www.gnu.org/licenses/>.  */

#include <glib-object.h>
#include <gee.h>
#include <glib.h>
#include <gobject/gvaluecollector.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_MACRO (macro_get_type ())
#define MACRO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MACRO, Macro))
#define MACRO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MACRO, MacroClass))
#define IS_MACRO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MACRO))
#define IS_MACRO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MACRO))
#define MACRO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MACRO, MacroClass))

typedef struct _Macro Macro;
typedef struct _MacroClass MacroClass;
typedef struct _MacroPrivate MacroPrivate;
typedef guint Keystroke;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ParamSpecMacro ParamSpecMacro;
#define _macro_unref0(var) ((var == NULL) ? NULL : (var = (macro_unref (var), NULL)))
typedef enum  {
	FLAGS_NEED_RESYNC = 1 << 0,
	FLAGS_SET_UNIARG = 1 << 1,
	FLAGS_UNIARG_EMPTY = 1 << 2,
	FLAGS_DEFINING_MACRO = 1 << 3
} Flags;

#define TYPE_FLAGS (flags_get_type ())
typedef gboolean (*Function) (glong uniarg, GeeQueue* args);

#define TYPE_LISP_FUNC (lisp_func_get_type ())
#define LISP_FUNC(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LISP_FUNC, LispFunc))
#define LISP_FUNC_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LISP_FUNC, LispFuncClass))
#define IS_LISP_FUNC(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LISP_FUNC))
#define IS_LISP_FUNC_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LISP_FUNC))
#define LISP_FUNC_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LISP_FUNC, LispFuncClass))

typedef struct _LispFunc LispFunc;
typedef struct _LispFuncClass LispFuncClass;
#define _lisp_func_unref0(var) ((var == NULL) ? NULL : (var = (lisp_func_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef gboolean (*MovementDelegate) (gpointer user_data);
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Macro {
	GTypeInstance parent_instance;
	volatile int ref_count;
	MacroPrivate * priv;
	GeeList* keys;
};

struct _MacroClass {
	GTypeClass parent_class;
	void (*finalize) (Macro *self);
};

struct _ParamSpecMacro {
	GParamSpec parent_instance;
};

static gpointer macro_parent_class = NULL;
VALA_EXTERN Macro* cur_mp;
Macro* cur_mp = NULL;
VALA_EXTERN Macro* cmd_mp;
Macro* cmd_mp = NULL;
VALA_EXTERN Flags thisflag;
VALA_EXTERN GeeList* macro_keys;
GeeList* macro_keys = NULL;

VALA_EXTERN gpointer macro_ref (gpointer instance);
VALA_EXTERN void macro_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_macro (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags);
VALA_EXTERN void value_set_macro (GValue* value,
                      gpointer v_object);
VALA_EXTERN void value_take_macro (GValue* value,
                       gpointer v_object);
VALA_EXTERN gpointer value_get_macro (const GValue* value);
VALA_EXTERN GType macro_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Macro, macro_unref)
VALA_EXTERN Macro* macro_new (void);
VALA_EXTERN Macro* macro_construct (GType object_type);
static void macro_finalize (Macro * obj);
static GType macro_get_type_once (void);
VALA_EXTERN void add_cmd_to_macro (void);
VALA_EXTERN void add_key_to_cmd (Keystroke key);
VALA_EXTERN void remove_key_from_cmd (void);
VALA_EXTERN void cancel_kbd_macro (void);
VALA_EXTERN GType flags_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gboolean call_macro (void);
VALA_EXTERN guint term_buf_len (void);
VALA_EXTERN void pushkey (Keystroke key);
VALA_EXTERN void get_and_run_command (void);
VALA_EXTERN void macro_init (void);
static gboolean __lambda114_ (glong uniarg,
                       GeeQueue* args);
VALA_EXTERN void minibuf_error (const gchar* fmt,
                    ...);
VALA_EXTERN void minibuf_write (const gchar* fmt,
                    ...);
static gboolean ___lambda114__function (glong uniarg,
                                 GeeQueue* args);
VALA_EXTERN LispFunc* lisp_func_new (const gchar* name,
                         Function func,
                         gboolean interactive,
                         const gchar* doc);
VALA_EXTERN LispFunc* lisp_func_construct (GType object_type,
                               const gchar* name,
                               Function func,
                               gboolean interactive,
                               const gchar* doc);
VALA_EXTERN gpointer lisp_func_ref (gpointer instance);
VALA_EXTERN void lisp_func_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_lisp_func (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
VALA_EXTERN void value_set_lisp_func (GValue* value,
                          gpointer v_object);
VALA_EXTERN void value_take_lisp_func (GValue* value,
                           gpointer v_object);
VALA_EXTERN gpointer value_get_lisp_func (const GValue* value);
VALA_EXTERN GType lisp_func_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LispFunc, lisp_func_unref)
static gboolean __lambda115_ (glong uniarg,
                       GeeQueue* args);
static gboolean ___lambda115__function (glong uniarg,
                                 GeeQueue* args);
static gboolean __lambda116_ (glong uniarg,
                       GeeQueue* _);
VALA_EXTERN gchar* keyvectostr (GeeList* keys);
VALA_EXTERN gboolean funcall (const gchar* name,
                  glong* maybe_uniarg,
                  GeeQueue* args);
static gboolean ___lambda116__function (glong uniarg,
                                 GeeQueue* args);
static gboolean __lambda117_ (glong uniarg,
                       GeeQueue* args);
VALA_EXTERN GeeList* keystrtovec (const gchar* key);
VALA_EXTERN gboolean execute_with_uniarg (glong uniarg,
                              MovementDelegate forward,
                              gpointer forward_target,
                              MovementDelegate backward,
                              gpointer backward_target);
static gboolean _call_macro_movement_delegate (gpointer self);
static gboolean ___lambda117__function (glong uniarg,
                                 GeeQueue* args);

Macro*
macro_construct (GType object_type)
{
	Macro* self = NULL;
	GeeArrayList* _tmp0_;
#line 25 "src/macro.vala"
	self = (Macro*) g_type_create_instance (object_type);
#line 26 "src/macro.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL);
#line 26 "src/macro.vala"
	_g_object_unref0 (self->keys);
#line 26 "src/macro.vala"
	self->keys = (GeeList*) _tmp0_;
#line 25 "src/macro.vala"
	return self;
#line 213 "macro.c"
}

Macro*
macro_new (void)
{
#line 25 "src/macro.vala"
	return macro_construct (TYPE_MACRO);
#line 221 "macro.c"
}

static void
value_macro_init (GValue* value)
{
#line 22 "src/macro.vala"
	value->data[0].v_pointer = NULL;
#line 229 "macro.c"
}

static void
value_macro_free_value (GValue* value)
{
#line 22 "src/macro.vala"
	if (value->data[0].v_pointer) {
#line 22 "src/macro.vala"
		macro_unref (value->data[0].v_pointer);
#line 239 "macro.c"
	}
}

static void
value_macro_copy_value (const GValue* src_value,
                        GValue* dest_value)
{
#line 22 "src/macro.vala"
	if (src_value->data[0].v_pointer) {
#line 22 "src/macro.vala"
		dest_value->data[0].v_pointer = macro_ref (src_value->data[0].v_pointer);
#line 251 "macro.c"
	} else {
#line 22 "src/macro.vala"
		dest_value->data[0].v_pointer = NULL;
#line 255 "macro.c"
	}
}

static gpointer
value_macro_peek_pointer (const GValue* value)
{
#line 22 "src/macro.vala"
	return value->data[0].v_pointer;
#line 264 "macro.c"
}

static gchar*
value_macro_collect_value (GValue* value,
                           guint n_collect_values,
                           GTypeCValue* collect_values,
                           guint collect_flags)
{
#line 22 "src/macro.vala"
	if (collect_values[0].v_pointer) {
#line 275 "macro.c"
		Macro * object;
		object = collect_values[0].v_pointer;
#line 22 "src/macro.vala"
		if (object->parent_instance.g_class == NULL) {
#line 22 "src/macro.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 282 "macro.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 22 "src/macro.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 286 "macro.c"
		}
#line 22 "src/macro.vala"
		value->data[0].v_pointer = macro_ref (object);
#line 290 "macro.c"
	} else {
#line 22 "src/macro.vala"
		value->data[0].v_pointer = NULL;
#line 294 "macro.c"
	}
#line 22 "src/macro.vala"
	return NULL;
#line 298 "macro.c"
}

static gchar*
value_macro_lcopy_value (const GValue* value,
                         guint n_collect_values,
                         GTypeCValue* collect_values,
                         guint collect_flags)
{
	Macro ** object_p;
	object_p = collect_values[0].v_pointer;
#line 22 "src/macro.vala"
	if (!object_p) {
#line 22 "src/macro.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 313 "macro.c"
	}
#line 22 "src/macro.vala"
	if (!value->data[0].v_pointer) {
#line 22 "src/macro.vala"
		*object_p = NULL;
#line 319 "macro.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 22 "src/macro.vala"
		*object_p = value->data[0].v_pointer;
#line 323 "macro.c"
	} else {
#line 22 "src/macro.vala"
		*object_p = macro_ref (value->data[0].v_pointer);
#line 327 "macro.c"
	}
#line 22 "src/macro.vala"
	return NULL;
#line 331 "macro.c"
}

GParamSpec*
param_spec_macro (const gchar* name,
                  const gchar* nick,
                  const gchar* blurb,
                  GType object_type,
                  GParamFlags flags)
{
	ParamSpecMacro* spec;
#line 22 "src/macro.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_MACRO), NULL);
#line 22 "src/macro.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 22 "src/macro.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 22 "src/macro.vala"
	return G_PARAM_SPEC (spec);
#line 350 "macro.c"
}

gpointer
value_get_macro (const GValue* value)
{
#line 22 "src/macro.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MACRO), NULL);
#line 22 "src/macro.vala"
	return value->data[0].v_pointer;
#line 360 "macro.c"
}

void
value_set_macro (GValue* value,
                 gpointer v_object)
{
	Macro * old;
#line 22 "src/macro.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MACRO));
#line 22 "src/macro.vala"
	old = value->data[0].v_pointer;
#line 22 "src/macro.vala"
	if (v_object) {
#line 22 "src/macro.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_MACRO));
#line 22 "src/macro.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "src/macro.vala"
		value->data[0].v_pointer = v_object;
#line 22 "src/macro.vala"
		macro_ref (value->data[0].v_pointer);
#line 382 "macro.c"
	} else {
#line 22 "src/macro.vala"
		value->data[0].v_pointer = NULL;
#line 386 "macro.c"
	}
#line 22 "src/macro.vala"
	if (old) {
#line 22 "src/macro.vala"
		macro_unref (old);
#line 392 "macro.c"
	}
}

void
value_take_macro (GValue* value,
                  gpointer v_object)
{
	Macro * old;
#line 22 "src/macro.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MACRO));
#line 22 "src/macro.vala"
	old = value->data[0].v_pointer;
#line 22 "src/macro.vala"
	if (v_object) {
#line 22 "src/macro.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_MACRO));
#line 22 "src/macro.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "src/macro.vala"
		value->data[0].v_pointer = v_object;
#line 413 "macro.c"
	} else {
#line 22 "src/macro.vala"
		value->data[0].v_pointer = NULL;
#line 417 "macro.c"
	}
#line 22 "src/macro.vala"
	if (old) {
#line 22 "src/macro.vala"
		macro_unref (old);
#line 423 "macro.c"
	}
}

static void
macro_class_init (MacroClass * klass,
                  gpointer klass_data)
{
#line 22 "src/macro.vala"
	macro_parent_class = g_type_class_peek_parent (klass);
#line 22 "src/macro.vala"
	((MacroClass *) klass)->finalize = macro_finalize;
#line 435 "macro.c"
}

static void
macro_instance_init (Macro * self,
                     gpointer klass)
{
#line 22 "src/macro.vala"
	self->ref_count = 1;
#line 444 "macro.c"
}

static void
macro_finalize (Macro * obj)
{
	Macro * self;
#line 22 "src/macro.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MACRO, Macro);
#line 22 "src/macro.vala"
	g_signal_handlers_destroy (self);
#line 23 "src/macro.vala"
	_g_object_unref0 (self->keys);
#line 457 "macro.c"
}

static GType
macro_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_macro_init, value_macro_free_value, value_macro_copy_value, value_macro_peek_pointer, "p", value_macro_collect_value, "p", value_macro_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (MacroClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) macro_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Macro), 0, (GInstanceInitFunc) macro_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType macro_type_id;
	macro_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Macro", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return macro_type_id;
}

GType
macro_get_type (void)
{
	static volatile gsize macro_type_id__once = 0;
	if (g_once_init_enter (&macro_type_id__once)) {
		GType macro_type_id;
		macro_type_id = macro_get_type_once ();
		g_once_init_leave (&macro_type_id__once, macro_type_id);
	}
	return macro_type_id__once;
}

gpointer
macro_ref (gpointer instance)
{
	Macro * self;
	self = instance;
#line 22 "src/macro.vala"
	g_atomic_int_inc (&self->ref_count);
#line 22 "src/macro.vala"
	return instance;
#line 492 "macro.c"
}

void
macro_unref (gpointer instance)
{
	Macro * self;
	self = instance;
#line 22 "src/macro.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 22 "src/macro.vala"
		MACRO_GET_CLASS (self)->finalize (self);
#line 22 "src/macro.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 506 "macro.c"
	}
}

void
add_cmd_to_macro (void)
{
	Macro* _tmp0_;
	Macro* _tmp1_;
	GeeList* _tmp2_;
	Macro* _tmp3_;
	GeeList* _tmp4_;
#line 34 "src/macro.vala"
	_tmp0_ = cmd_mp;
#line 34 "src/macro.vala"
	_vala_assert (_tmp0_ != NULL, "cmd_mp != null");
#line 35 "src/macro.vala"
	_tmp1_ = cur_mp;
#line 35 "src/macro.vala"
	_tmp2_ = _tmp1_->keys;
#line 35 "src/macro.vala"
	_tmp3_ = cmd_mp;
#line 35 "src/macro.vala"
	_tmp4_ = _tmp3_->keys;
#line 35 "src/macro.vala"
	gee_collection_add_all ((GeeCollection*) _tmp2_, (GeeCollection*) _tmp4_);
#line 36 "src/macro.vala"
	_macro_unref0 (cmd_mp);
#line 36 "src/macro.vala"
	cmd_mp = NULL;
#line 536 "macro.c"
}

void
add_key_to_cmd (Keystroke key)
{
	Macro* _tmp0_;
	Macro* _tmp2_;
	GeeList* _tmp3_;
#line 40 "src/macro.vala"
	_tmp0_ = cmd_mp;
#line 40 "src/macro.vala"
	if (_tmp0_ == NULL) {
#line 549 "macro.c"
		Macro* _tmp1_;
#line 41 "src/macro.vala"
		_tmp1_ = macro_new ();
#line 41 "src/macro.vala"
		_macro_unref0 (cmd_mp);
#line 41 "src/macro.vala"
		cmd_mp = _tmp1_;
#line 557 "macro.c"
	}
#line 43 "src/macro.vala"
	_tmp2_ = cur_mp;
#line 43 "src/macro.vala"
	_tmp3_ = _tmp2_->keys;
#line 43 "src/macro.vala"
	gee_collection_add ((GeeCollection*) _tmp3_, (gpointer) ((guintptr) key));
#line 565 "macro.c"
}

void
remove_key_from_cmd (void)
{
	Macro* _tmp0_;
	Macro* _tmp1_;
	GeeList* _tmp2_;
	Macro* _tmp3_;
	GeeList* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
#line 47 "src/macro.vala"
	_tmp0_ = cmd_mp;
#line 47 "src/macro.vala"
	_vala_assert (_tmp0_ != NULL, "cmd_mp != null");
#line 48 "src/macro.vala"
	_tmp1_ = cmd_mp;
#line 48 "src/macro.vala"
	_tmp2_ = _tmp1_->keys;
#line 48 "src/macro.vala"
	_tmp3_ = cmd_mp;
#line 48 "src/macro.vala"
	_tmp4_ = _tmp3_->keys;
#line 48 "src/macro.vala"
	_tmp5_ = gee_collection_get_size ((GeeCollection*) _tmp4_);
#line 48 "src/macro.vala"
	_tmp6_ = _tmp5_;
#line 48 "src/macro.vala"
	gee_list_remove_at (_tmp2_, _tmp6_ - 1);
#line 596 "macro.c"
}

static gpointer
_macro_ref0 (gpointer self)
{
#line 52 "src/macro.vala"
	return self ? macro_ref (self) : NULL;
#line 604 "macro.c"
}

void
cancel_kbd_macro (void)
{
	Macro* _tmp0_;
	Macro* _tmp1_;
#line 52 "src/macro.vala"
	_macro_unref0 (cur_mp);
#line 52 "src/macro.vala"
	cur_mp = NULL;
#line 52 "src/macro.vala"
	_tmp0_ = cur_mp;
#line 52 "src/macro.vala"
	_tmp1_ = _macro_ref0 (_tmp0_);
#line 52 "src/macro.vala"
	_macro_unref0 (cmd_mp);
#line 52 "src/macro.vala"
	cmd_mp = _tmp1_;
#line 53 "src/macro.vala"
	thisflag = thisflag & (~FLAGS_DEFINING_MACRO);
#line 626 "macro.c"
}

gboolean
call_macro (void)
{
	gsize cur = 0UL;
	gboolean result;
#line 59 "src/macro.vala"
	cur = (gsize) term_buf_len ();
#line 636 "macro.c"
	{
		guint i = 0U;
#line 60 "src/macro.vala"
		i = (guint) 0;
#line 641 "macro.c"
		{
			gboolean _tmp0_ = FALSE;
#line 60 "src/macro.vala"
			_tmp0_ = TRUE;
#line 60 "src/macro.vala"
			while (TRUE) {
#line 648 "macro.c"
				GeeList* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				GeeList* _tmp5_;
				GeeList* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
				gpointer _tmp9_;
#line 60 "src/macro.vala"
				if (!_tmp0_) {
#line 659 "macro.c"
					guint _tmp1_;
#line 60 "src/macro.vala"
					_tmp1_ = i;
#line 60 "src/macro.vala"
					i = _tmp1_ + 1;
#line 665 "macro.c"
				}
#line 60 "src/macro.vala"
				_tmp0_ = FALSE;
#line 60 "src/macro.vala"
				_tmp2_ = macro_keys;
#line 60 "src/macro.vala"
				_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 60 "src/macro.vala"
				_tmp4_ = _tmp3_;
#line 60 "src/macro.vala"
				if (!(i < ((guint) _tmp4_))) {
#line 60 "src/macro.vala"
					break;
#line 679 "macro.c"
				}
#line 61 "src/macro.vala"
				_tmp5_ = macro_keys;
#line 61 "src/macro.vala"
				_tmp6_ = macro_keys;
#line 61 "src/macro.vala"
				_tmp7_ = gee_collection_get_size ((GeeCollection*) _tmp6_);
#line 61 "src/macro.vala"
				_tmp8_ = _tmp7_;
#line 61 "src/macro.vala"
				_tmp9_ = gee_list_get (_tmp5_, (gint) ((_tmp8_ - i) - 1));
#line 61 "src/macro.vala"
				pushkey ((Keystroke) ((guintptr) _tmp9_));
#line 693 "macro.c"
			}
		}
	}
#line 63 "src/macro.vala"
	while (TRUE) {
#line 63 "src/macro.vala"
		if (!(((gsize) term_buf_len ()) > cur)) {
#line 63 "src/macro.vala"
			break;
#line 703 "macro.c"
		}
#line 64 "src/macro.vala"
		get_and_run_command ();
#line 707 "macro.c"
	}
#line 66 "src/macro.vala"
	result = TRUE;
#line 66 "src/macro.vala"
	return result;
#line 713 "macro.c"
}

static gboolean
__lambda114_ (glong uniarg,
              GeeQueue* args)
{
	Macro* _tmp0_;
	Macro* _tmp1_;
	gboolean result;
#line 74 "src/macro.vala"
	if ((thisflag & FLAGS_DEFINING_MACRO) == FLAGS_DEFINING_MACRO) {
#line 75 "src/macro.vala"
		minibuf_error ("Already defining a keyboard macro", NULL);
#line 76 "src/macro.vala"
		result = FALSE;
#line 76 "src/macro.vala"
		return result;
#line 731 "macro.c"
	}
#line 79 "src/macro.vala"
	_tmp0_ = cur_mp;
#line 79 "src/macro.vala"
	if (_tmp0_ != NULL) {
#line 80 "src/macro.vala"
		cancel_kbd_macro ();
#line 739 "macro.c"
	}
#line 82 "src/macro.vala"
	minibuf_write ("Defining keyboard macro...", NULL);
#line 84 "src/macro.vala"
	thisflag = thisflag | FLAGS_DEFINING_MACRO;
#line 85 "src/macro.vala"
	_tmp1_ = macro_new ();
#line 85 "src/macro.vala"
	_macro_unref0 (cur_mp);
#line 85 "src/macro.vala"
	cur_mp = _tmp1_;
#line 87 "src/macro.vala"
	result = TRUE;
#line 87 "src/macro.vala"
	return result;
#line 755 "macro.c"
}

static gboolean
___lambda114__function (glong uniarg,
                        GeeQueue* args)
{
	gboolean result;
	result = __lambda114_ (uniarg, args);
#line 71 "src/macro.vala"
	return result;
#line 766 "macro.c"
}

static gboolean
__lambda115_ (glong uniarg,
              GeeQueue* args)
{
	gboolean result;
#line 98 "src/macro.vala"
	if (!((thisflag & FLAGS_DEFINING_MACRO) == FLAGS_DEFINING_MACRO)) {
#line 99 "src/macro.vala"
		minibuf_error ("Not defining a keyboard macro", NULL);
#line 100 "src/macro.vala"
		result = FALSE;
#line 100 "src/macro.vala"
		return result;
#line 782 "macro.c"
	}
#line 103 "src/macro.vala"
	thisflag = thisflag & (~FLAGS_DEFINING_MACRO);
#line 104 "src/macro.vala"
	result = TRUE;
#line 104 "src/macro.vala"
	return result;
#line 790 "macro.c"
}

static gboolean
___lambda115__function (glong uniarg,
                        GeeQueue* args)
{
	gboolean result;
	result = __lambda115_ (uniarg, args);
#line 95 "src/macro.vala"
	return result;
#line 801 "macro.c"
}

static gboolean
__lambda116_ (glong uniarg,
              GeeQueue* _)
{
	Macro* _tmp0_;
	GeeArrayQueue* args = NULL;
	GeeArrayQueue* _tmp1_;
	GeeArrayQueue* _tmp2_;
	Macro* _tmp3_;
	GeeList* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GeeArrayQueue* _tmp7_;
	gboolean result;
#line 115 "src/macro.vala"
	_tmp0_ = cur_mp;
#line 115 "src/macro.vala"
	if (_tmp0_ == NULL) {
#line 116 "src/macro.vala"
		minibuf_error ("No kbd macro has been defined", NULL);
#line 117 "src/macro.vala"
		result = FALSE;
#line 117 "src/macro.vala"
		return result;
#line 828 "macro.c"
	}
#line 120 "src/macro.vala"
	_tmp1_ = gee_array_queue_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 120 "src/macro.vala"
	args = _tmp1_;
#line 121 "src/macro.vala"
	_tmp2_ = args;
#line 121 "src/macro.vala"
	_tmp3_ = cur_mp;
#line 121 "src/macro.vala"
	_tmp4_ = _tmp3_->keys;
#line 121 "src/macro.vala"
	_tmp5_ = keyvectostr (_tmp4_);
#line 121 "src/macro.vala"
	_tmp6_ = _tmp5_;
#line 121 "src/macro.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp2_, _tmp6_);
#line 121 "src/macro.vala"
	_g_free0 (_tmp6_);
#line 122 "src/macro.vala"
	_tmp7_ = args;
#line 122 "src/macro.vala"
	funcall ("execute-kbd-macro", &uniarg, (GeeQueue*) _tmp7_);
#line 123 "src/macro.vala"
	result = TRUE;
#line 123 "src/macro.vala"
	_g_object_unref0 (args);
#line 123 "src/macro.vala"
	return result;
#line 858 "macro.c"
}

static gboolean
___lambda116__function (glong uniarg,
                        GeeQueue* args)
{
	gboolean result;
	result = __lambda116_ (uniarg, args);
#line 112 "src/macro.vala"
	return result;
#line 869 "macro.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 138 "src/macro.vala"
	return self ? g_object_ref (self) : NULL;
#line 877 "macro.c"
}

static gboolean
_call_macro_movement_delegate (gpointer self)
{
	gboolean result;
	result = call_macro ();
#line 139 "src/macro.vala"
	return result;
#line 887 "macro.c"
}

static gboolean
__lambda117_ (glong uniarg,
              GeeQueue* args)
{
	gchar* keystr = NULL;
	gpointer _tmp0_;
	GeeList* keys = NULL;
	const gchar* _tmp1_;
	GeeList* _tmp2_;
	GeeList* _tmp3_;
	GeeList* _tmp4_;
	GeeList* _tmp5_;
	gboolean result;
#line 133 "src/macro.vala"
	_tmp0_ = gee_queue_poll (args);
#line 133 "src/macro.vala"
	keystr = (gchar*) _tmp0_;
#line 134 "src/macro.vala"
	_tmp1_ = keystr;
#line 134 "src/macro.vala"
	_tmp2_ = keystrtovec (_tmp1_);
#line 134 "src/macro.vala"
	keys = _tmp2_;
#line 135 "src/macro.vala"
	_tmp3_ = keys;
#line 135 "src/macro.vala"
	if (_tmp3_ == NULL) {
#line 136 "src/macro.vala"
		result = FALSE;
#line 136 "src/macro.vala"
		_g_object_unref0 (keys);
#line 136 "src/macro.vala"
		_g_free0 (keystr);
#line 136 "src/macro.vala"
		return result;
#line 925 "macro.c"
	}
#line 138 "src/macro.vala"
	_tmp4_ = keys;
#line 138 "src/macro.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 138 "src/macro.vala"
	_g_object_unref0 (macro_keys);
#line 138 "src/macro.vala"
	macro_keys = _tmp5_;
#line 139 "src/macro.vala"
	execute_with_uniarg (uniarg, _call_macro_movement_delegate, NULL, NULL, NULL);
#line 140 "src/macro.vala"
	result = TRUE;
#line 140 "src/macro.vala"
	_g_object_unref0 (keys);
#line 140 "src/macro.vala"
	_g_free0 (keystr);
#line 140 "src/macro.vala"
	return result;
#line 945 "macro.c"
}

static gboolean
___lambda117__function (glong uniarg,
                        GeeQueue* args)
{
	gboolean result;
	result = __lambda117_ (uniarg, args);
#line 130 "src/macro.vala"
	return result;
#line 956 "macro.c"
}

void
macro_init (void)
{
	LispFunc* _tmp0_;
	LispFunc* _tmp1_;
	LispFunc* _tmp2_;
	LispFunc* _tmp3_;
	LispFunc* _tmp4_;
	LispFunc* _tmp5_;
	LispFunc* _tmp6_;
	LispFunc* _tmp7_;
#line 71 "src/macro.vala"
	_tmp0_ = lisp_func_new ("start-kbd-macro", ___lambda114__function, TRUE, "Record subsequent keyboard input, defining a keyboard macro.\n" \
"\t\tThe commands are recorded even as they are executed.\n" \
"\t\tUse \\\\[end-kbd-macro] to finish recording and make the macro ava" \
"ilable.");
#line 71 "src/macro.vala"
	_tmp1_ = _tmp0_;
#line 71 "src/macro.vala"
	_lisp_func_unref0 (_tmp1_);
#line 95 "src/macro.vala"
	_tmp2_ = lisp_func_new ("end-kbd-macro", ___lambda115__function, TRUE, "Finish defining a keyboard macro.\n" \
"\t\tThe definition was started by \\\\[start-kbd-macro].\n" \
"\t\tThe macro is now available for use via \\\\[call-last-kbd-macro].");
#line 95 "src/macro.vala"
	_tmp3_ = _tmp2_;
#line 95 "src/macro.vala"
	_lisp_func_unref0 (_tmp3_);
#line 112 "src/macro.vala"
	_tmp4_ = lisp_func_new ("call-last-kbd-macro", ___lambda116__function, TRUE, "Call the last keyboard macro that you defined with \\\\[start-kbd-macr" \
"o].\n" \
"\t\tA prefix argument serves as a repeat count.");
#line 112 "src/macro.vala"
	_tmp5_ = _tmp4_;
#line 112 "src/macro.vala"
	_lisp_func_unref0 (_tmp5_);
#line 130 "src/macro.vala"
	_tmp6_ = lisp_func_new ("execute-kbd-macro", ___lambda117__function, TRUE, "Execute macro as string of editor command characters.");
#line 130 "src/macro.vala"
	_tmp7_ = _tmp6_;
#line 130 "src/macro.vala"
	_lisp_func_unref0 (_tmp7_);
#line 994 "macro.c"
}

